/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDataquierNotesRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierNotes extends TableImpl<VDataquierNotesRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier_notes</code>
     */
    public static final VDataquierNotes V_DATAQUIER_NOTES = new VDataquierNotes();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierNotesRecord> getRecordType() {
        return VDataquierNotesRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_notes.fk_element</code>.
     */
    public final TableField<VDataquierNotesRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_notes.note_de</code>.
     */
    public final TableField<VDataquierNotesRecord, String> NOTE_DE = createField(DSL.name("note_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_notes.note_en</code>.
     */
    public final TableField<VDataquierNotesRecord, String> NOTE_EN = createField(DSL.name("note_en"), SQLDataType.CLOB, this, "");

    private VDataquierNotes(Name alias, Table<VDataquierNotesRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierNotes(Name alias, Table<VDataquierNotesRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_notes" as  SELECT n.fk_element,
          tde.value AS note_de,
          ten.value AS note_en
         FROM ((common_dd.t_core_elementnote n
           LEFT JOIN common_dd.t_core_translation tde ON (((tde.fk_trans_key = n.fk_note_lang) AND (tde.isocode = 'de_DE'::common_dd.enum_isocode))))
           LEFT JOIN common_dd.t_core_translation ten ON (((ten.fk_trans_key = n.fk_note_lang) AND (ten.isocode = 'en'::common_dd.enum_isocode))))
        WHERE (n.note_type = '1 - data quality for request form'::common_dd.enum_elementnote);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_notes</code> table
     * reference
     */
    public VDataquierNotes(String alias) {
        this(DSL.name(alias), V_DATAQUIER_NOTES);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_notes</code> table
     * reference
     */
    public VDataquierNotes(Name alias) {
        this(alias, V_DATAQUIER_NOTES);
    }

    /**
     * Create a <code>common_dd.v_dataquier_notes</code> table reference
     */
    public VDataquierNotes() {
        this(DSL.name("v_dataquier_notes"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierNotes as(String alias) {
        return new VDataquierNotes(DSL.name(alias), this);
    }

    @Override
    public VDataquierNotes as(Name alias) {
        return new VDataquierNotes(alias, this);
    }

    @Override
    public VDataquierNotes as(Table<?> alias) {
        return new VDataquierNotes(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierNotes rename(String name) {
        return new VDataquierNotes(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierNotes rename(Name name) {
        return new VDataquierNotes(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierNotes rename(Table<?> name) {
        return new VDataquierNotes(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes where(Condition condition) {
        return new VDataquierNotes(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierNotes where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierNotes where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierNotes where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierNotes where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierNotes whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
